#1797 closed defect (fixed)

malloc() are limited to the 1st 32 MB on the PowerPC BSPs

Reported by: feng1 Owned by: Joel Sherrill
Priority: normal Milestone: 4.11
Component: bsps Version: 4.10
Severity: critical Keywords:
Cc: strauman@… Blocked By:
Blocking:

Description

bsp_sbrk_init() was declared at powerpc/shared/startup/bspgetworkarea.c and
its returned value was not passed along to bsp_libc_init(), which limited
malloc() only up to the 1st 32 MB of memory that no PPC BSP could extend to
allocate more memory, once the 32 MB is used up. The attached patch
allowed one to malloc() beyond 32 MB. Besides, it fixed the value of
heap_start & heap_size for the single-heap case. It complies with Joel
Sherrill's future plan for memory protection, but yet does not interfere
with the functions of other non-PowerPC BSPs. Thanks to everyone's feedback
and contribution. Please see ChangeLog? for details.

Attachments (1)

rtems-4.10.0-heapspace_05162011.diff (6.1 KB) - added by feng1 on May 16, 2011 at 5:36:21 PM.
Fixed the bugs for the limitation of the 1st 32 MB of memory on PPC BSPs.

Download all attachments as: .zip

Change History (3)

Changed on May 16, 2011 at 5:36:21 PM by feng1

Fixed the bugs for the limitation of the 1st 32 MB of memory on PPC BSPs.

comment:1 Changed on May 24, 2011 at 1:35:36 PM by Joel Sherrill

Cc: strauman added

comment:2 Changed on Feb 22, 2012 at 8:44:47 AM by strauman

Resolution: fixed
Status: newclosed

Fix applied on 2011-5-18 on rtems-4.10 branch (i.e., fixed in 4.10.1) and HEAD.

Note: See TracTickets for help on using tickets.